# Copyright 2024 Cegal AS
# All rights reserved.
# Unauthorized copying of this file, via any medium is strictly prohibited.

from enum import Enum


class MeasurementNamesEnum(Enum):
    """The MeasurementNamesEnum defines commonly used measurement names"""

    StandardDepthIndex = "Standard_Depth_Index"
    ShortTime = "Short_Time"
    Length = "Length"
    Dimensionless = "Dimensionless"
    Frequency = "Frequency"
    Rotation = "Rotation"
    Area = "Area"
    Velocity = "Velocity"
    Ratio = "Ratio"
    AcousticImpedance = "Acoustic_Impedance"
    Temperature = "Temperature"
    PressureDensity = "Pressure_Density"
    Compressibility = "Compressibility"
    InverseArea = "Inverse_Area"
    ThermalConductivity = "Thermal_Conductivity"
    ThermalConductionTransmissibility = "Thermal_Conduction_Transmissibility"
    VolumetricHeatCapacity = "Volumetric_Heat_Capacity"
    VolumetricHeatCapacityPerTemperature = "Volumetric_Heat_Capacity_Per_Temperature"
    HeatTransferCoefficient = "Heat_Transfer_Coefficient"
    SpecificHeatCapacityPerTemperature = "Specific_Heat_Capacity_Per_Temperature"
    SpecificHeatCapacityPerTemperatureSquared = "Specific_Heat_Capacity_Per_Temperature_Squared"
    VaporizationHeat = "Vaporization_Heat"
    InverseTemperature = "Inverse_Temperature"
    InverseTemperatureSquared = "Inverse_Temperature_Squared"
    ThermalResistivity = "Thermal_Resistivity"
    Porosity = "Porosity"
    Permeability = "Permeability"
    Transmissibility = "Transmissibility"
    Pressure = "Pressure"
    DynamicViscosity = "Dynamic_Viscosity"
    Mobility = "Mobility"
    SimulationTime = "Simulation_Time"
    Diffusivity = "Diffusivity"
    CoalGasVolumePerMass = "Coal_Gas_Volume_Per_Mass"
    SurfaceTension = "Surface_Tension"
    Volume = "Volume"
    ReservoirProductionVolume = "Reservoir_Production_Volume"
    LiquidProductionVolume = "Liquid_Production_Volume"
    GasProductionVolume = "Gas_Production_Volume"
    LiquidFormationVolumeFactor = "Liquid_Formation_Volume_Factor"
    GasFormationVolumeFactor = "Gas_Formation_Volume_Factor"
    LowAcousticSlowness = "Low_Acoustic_Slowness"
    APIGammaRay = "API_Gamma_Ray"
    UraniumConcentration = "Uranium_Concentration"
    ThoriumConcentration = "Thorium_Concentration"
    PotassiumConcentration = "Potassium_Concentration"
    Percent = "Percent"
    Resistivity = "Resistivity"
    Density = "Density"
    LowElectricPotential = "Low_Electric_Potential"
    Conductivity = "Conductivity"
    CylinderDiameter = "Cylinder_Diameter"
    SmallRotationPerLength = "Small_Rotation_Per_Length"
    PressureGradient = "Pressure_Gradient"
    ReservoirFlowrate = "Reservoir_Flowrate"
    Fraction = "Fraction"
    LiquidProductivityIndex = "Liquid_Productivity_Index"
    GasProductivityIndex = "Gas_Productivity_Index"
    CompressibleFluidProductivityIndex = "Compressible_Fluid_Productivity_Index"
    PipeCrossSectionalArea = "Pipe_Cross_Sectional_Area"
    PressurePerFlowrateSquared = "Pressure_Per_Flowrate_Squared"
    LiquidFlowrate = "Liquid_Flowrate"
    GasFlowrate = "Gas_Flowrate"
    HighMass = "High_Mass"
    HighMassPerTime = "High_Mass_Per_Time"
    LiquidToLiquidRatio = "Liquid_To_Liquid_Ratio"
    EnergyRate = "Energy_Rate"
    ReservoirEnergyDensity = "Reservoir_Energy_Density"
    MassPerArea = "Mass_Per_Area"
    PowerPerArea = "Power_Per_Area"
    GeologicTime = "Geologic_Time"
    HydrogenIndex = "Hydrogen_Index"
    ThermalGradient = "Thermal_Gradient"
    Probability = "Probability"
    MolarMass = "Molar_Mass"
    AmountOfSubstance = "Amount_Of_Substance"
    MolarRate = "Molar_Rate"
    MolarVolume = "Molar_Volume"
    MolarDensity = "Molar_Density"
    MolarEnthalpy = "Molar_Enthalpy"
    NormalizedQuantity = "Normalized_Quantity"
    Mass = "Mass"
    MassPerTime = "Mass_Per_Time"
    MassConcentration = "Mass_Concentration"
    CoalGasConcentration = "Coal_Gas_Concentration"
    Holdup = "Holdup"
    ErosionalVelocity = "Erosional_Velocity"
    ErosionRate = "Erosion_Rate"
    CorrosionRate = "Corrosion_Rate"
    MotorSpeed = "Motor_Speed"
    TimeDip = "TimeDip"
