# Copyright 2024 Cegal AS
# All rights reserved.
# Unauthorized copying of this file, via any medium is strictly prohibited.

from enum import Enum


class TemplateNamesEnum(Enum):
    """The TemplateNamesEnum defines commonly used template names"""

    # DiscreteFractureProperty
    FracturePatchSet = "FracturePatchSet"

    # DiscreteLogTypes
    CompletionCasedLog = "CompletionCasedLog"
    CompletionGeneral = "CompletionGeneral"
    CompletionLinedLog = "CompletionLinedLog"
    Perforation = "Perforation"
    ProductionStatus = "ProductionStatus"
    SlidingSleevePositions = "SlidingSleevePositions"

    # DiscreteMiscellaneous
    HistoryMatchQualitativeCoarse = "HistoryMatchQualitativeCoarse"
    HistoryMatchQualitativeFine = "HistoryMatchQualitativeFine"
    HoleClassification = "HoleClassification"

    # Facies
    ActiveCellFlag = "ActiveCellFlag"
    Bodies = "Bodies"
    BooleanProperty = "BooleanProperty"
    BoreholeIndex = "BoreholeIndex"
    ConnectedVolume = "ConnectedVolume"
    DictionaryGeneral = "DictionaryGeneral"
    DipClassification = "DipClassification"
    Facies = "Facies"
    Faults = "Faults"
    Fluids = "Fluids"
    FluvialFacies = "FluvialFacies"
    Horizons = "Horizons"
    Lithologies = "Lithologies"
    RegionId = "RegionId"
    Segments = "Segments"
    StairstepLayers = "StairstepLayers"
    StairstepSegments = "StairstepSegments"
    Strings = "Strings"
    TimeStratigraphy = "TimeStratigraphy"
    ZonesAllK = "ZonesAllK"
    ZoneLog = "Zone log from 'Well Tops'"
    ZonesMain = "ZonesMain"
    ZonesSub = "ZonesSub"
    ZonesSubHierarchy = "ZonesSubHierarchy"

    # FaultProperty
    FaultDisplacement = "FaultDisplacement"
    FaultPermeability = "FaultPermeability"
    FaultThickness = "FaultThickness"
    ShaleGougeRatio = "ShaleGougeRatio"
    TransmissibilityMultiplier = "TransmissibilityMultiplier"

    # Geomechanic
    RockDisplacement = "RockDisplacement"
    Strain = "Strain"
    StressEffective = "StressEffective"
    StressPrincipal = "StressPrincipal"
    StressTotal = "StressTotal"

    # Geometrical
    AboveContact = "AboveContact"
    Area = "Area"
    CellAngle = "CellAngle"
    CellDeltaX = "CellDeltaX"
    CellDeltaY = "CellDeltaY"
    CellDeltaZ = "CellDeltaZ"
    CellInsideOut = "CellInsideOut"
    CellTopDepth = "CellTopDepth"
    DepthContactGasOil = "DepthContactGasOil"
    DepthContactGasWater = "DepthContactGasWater"
    DepthContactOilWater = "DepthContactOilWater"
    DipAngle = "DipAngle"
    DipAzimuth = "DipAzimuth"
    DipQuality = "DipQuality"
    Distance = "Distance"
    MeasuredDepth = "MeasuredDepth"
    Residual = "Residual"
    TimeDelta = "TimeDelta"
    TimeOneWay = "TimeOneWay"
    TimeTwoWay = "TimeTwoWay"
    Uncertainty = "Uncertainty"

    # Geophysical
    CompressibilityRock = "CompressibilityRock"
    CompressibilityWater = "CompressibilityWater"
    DifferentialTemperature = "DifferentialTemperature"
    HeatTransferCoefficient = "HeatTransferCoefficient"
    HeatTransmissibility = "HeatTransmissibility"
    HeatTransmissibilityI = "HeatTransmissibilityI"
    HeatTransmissibilityJ = "HeatTransmissibilityJ"
    HeatTransmissibilityK = "HeatTransmissibilityK"
    ImpedanceAcoustic = "ImpedanceAcoustic"
    ImpedanceElasticPP = "ImpedanceElasticPP"
    ImpedanceElasticPS = "ImpedanceElasticPS"
    ImpedanceP = "ImpedanceP"
    ImpedanceS = "ImpedanceS"
    InverseTemperature = "InverseTemperature"
    InverseTemperatureSquared = "InverseTemperatureSquared"
    Lambda = "Lambda"
    LambdaTimesRho = "LambdaTimesRho"
    MatrixFractureCoupling = "MatrixFractureCoupling"
    MatrixFractureThermalCoupling = "MatrixFractureThermalCoupling"
    ModulusBulk = "ModulusBulk"
    ModulusCompressional = "ModulusCompressional"
    Mu = "Mu"
    MuTimesRho = "MuTimesRho"
    PoissonRatio = "PoissonRatio"
    ReflectionCoefficient = "ReflectionCoefficient"
    RelativeTemperature = "RelativeTemperature"
    RockDensity = "RockDensity"
    RockHeatCapacity = "RockHeatCapacity"
    RockHeatCapacityTemp = "RockHeatCapacityTemp"
    ShearModulus = "ShearModulus"
    Temperature = "Temperature"
    ThermalConductivity = "ThermalConductivity"
    ThermalConductivityCombined = "ThermalConductivityCombined"
    ThermalConductivityGas = "ThermalConductivityGas"
    ThermalConductivityOil = "ThermalConductivityOil"
    ThermalConductivityRock = "ThermalConductivityRock"
    ThermalConductivitySolid = "ThermalConductivitySolid"
    ThermalConductivityWater = "ThermalConductivityWater"
    ThermalResistance = "ThermalResistance"
    VaporizationHeat = "VaporizationHeat"
    Velocity = "Velocity"
    VelocityAverage = "VelocityAverage"
    VelocityGradientInitialV0 = "VelocityGradientInitialV0"
    VelocityGradientKFactor = "VelocityGradientKFactor"
    VelocityGradientKFactorInTime = "VelocityGradientKFactorInTime"
    VelocityInterval = "VelocityInterval"
    VelocityP = "VelocityP"
    VelocityRatio = "VelocityRatio"
    VelocityS = "VelocityS"
    VelocityStack = "VelocityStack"
    Wavelet = "Wavelet"
    ZFactor = "ZFactor"
    KFactor = "KFactor"
    V0Factor = "V0Factor"
    SpecificHeatCapacityPerTemperature = "SpecificHeatCapacityPerTemperature"
    SpecificHeatCapacityPerTemperatureSquared = "SpecificHeatCapacityPerTemperatureSquared"

    # LogTypes
    BulkDensityCorrection = "BulkDensityCorrection"
    Caliper = "Caliper"
    CaliperAcoustic = "CaliperAcoustic"
    CaliperMechanical = "CaliperMechanical"
    Conductivity = "Conductivity"
    ConductivityDeep = "ConductivityDeep"
    ConductivityMedium = "ConductivityMedium"
    ConductivityShallow = "ConductivityShallow"
    ConstantMudResistivity = "ConstantMudResistivity"
    ConstantWaterResistivity = "ConstantWaterResistivity"
    ConstantWaterSalinity = "ConstantWaterSalinity"
    Deepening = "Deepening"
    Density = "Density"
    DensityCompensatedBulk = "DensityCompensatedBulk"
    DensityDownwardAzimuth = "DensityDownwardAzimuth"
    DensityUpwardAzimuth = "DensityUpwardAzimuth"
    DoglegSeverity = "DoglegSeverity"
    GammaRay = "GammaRay"
    GammaRayPotassium = "GammaRayPotassium"
    GammaRayThorium = "GammaRayThorium"
    GammaRayUranium = "GammaRayUranium"
    GeneralProduction = "GeneralProduction"
    Neutron = "Neutron"
    OpenHole = "OpenHole"
    PerforationConnectivity = "PerforationConnectivity"
    PhotoelectricFactor = "PhotoelectricFactor"
    PressureGradient = "PressureGradient"
    PSonic = "PSonic"
    Resistivity = "Resistivity"
    ResistivityDeep = "ResistivityDeep"
    ResistivityMedium = "ResistivityMedium"
    ResistivityMicro = "ResistivityMicro"
    ResistivityShallow = "ResistivityShallow"
    Sonic = "Sonic"
    SpontaneousPotential = "SpontaneousPotential"
    SSonic = "SSonic"
    VolumeOfShale = "VolumeOfShale"
    WellBoreRadius = "WellBoreRadius"

    # LogTypes2D
    CapillaryPressure = "CapillaryPressure"
    FractionalFlow = "FractionalFlow"
    RelativePermeability = "RelativePermeability"
    T2Distribution = "T2Distribution"

    # Miscellaneous
    AmountOfSubstance = "AmountOfSubstance"
    CoalGasConcentration = "CoalGasConcentration"
    Concentration = "Concentration"
    CorrosionRate = "CorrosionRate"
    DistributionFrequency = "DistributionFrequency"
    ErosionRate = "ErosionRate"
    ErosionalVelocity = "ErosionalVelocity"
    Fraction = "Fraction"
    FromFacies = "FromFacies"
    GasFlowRate = "GasFlowRate"
    General = "General"
    GeneralDerivative = "GeneralDerivative"
    GeneralInteger = "GeneralInteger"
    HistoryMatchConstant = "HistoryMatchConstant"
    HistoryMatchPolyLine = "HistoryMatchPolyLine"
    HistoryMatchStepWise = "HistoryMatchStepWise"
    HistoryMatchQuantitative = "HistoryMatchQuantitative"
    Holdup = "Holdup"
    Intensity = "Intensity"
    Mass = "Mass"
    MassFlowRate = "MassFlowRate"
    MolarDensity = "MolarDensity"
    MolarEnthalpy = "MolarEnthalpy"
    MolarMass = "MolarMass"
    MolarRate = "MolarRate"
    MotorSpeed = "MotorSpeed"
    MolarVolume = "MolarVolume"
    Percent = "Percent"
    PlugbackTotalDepth = "PlugbackTotalDepth"
    PrincipalComponent = "PrincipalComponent"
    Probability = "Probability"
    OilFlowRate = "OilFlowRate"
    SummaryData = "SummaryData"
    TotalDepth = "TotalDepth"
    Variance = "Variance"
    WaterFlowRate = "WaterFlowRate"

    # Petrophysical
    Adsorption = "Adsorption"
    CoalGasVolumePerMass = "CoalGasVolumePerMass"
    Diffusivity = "Diffusivity"
    GasHeatCapacity = "GasHeatCapacity"
    GasVelocity = "GasVelocity"
    LithologyFraction = "LithologyFraction"
    Mobility = "Mobility"
    NetGross = "NetGross"
    NetPay = "NetPay"
    OilHeatCapacity = "OilHeatCapacity"
    OilVelocity = "OilVelocity"
    Permeability = "Permeability"
    PermeabilityI = "PermeabilityI"
    PermeabilityIJ = "PermeabilityIJ"
    PermeabilityIK = "PermeabilityIK"
    PermeabilityJ = "PermeabilityJ"
    PermeabilityJK = "PermeabilityJK"
    PermeabilityK = "PermeabilityK"
    PermeabilityMF = "PermeabilityMF"
    PermeabilityX = "PermeabilityX"
    PermeabilityXY = "PermeabilityXY"
    PermeabilityXZ = "PermeabilityXZ"
    PermeabilityY = "PermeabilityY"
    PermeabilityYZ = "PermeabilityYZ"
    PermeabilityZ = "PermeabilityZ"
    PoreVolumeMultiplier = "PoreVolumeMultiplier"
    Porosity = "Porosity"
    PorosityEffective = "PorosityEffective"
    PorosityTotal = "PorosityTotal"
    Pressure = "Pressure"
    SaturationCriticalGas = "SaturationCriticalGas"
    SaturationCriticalWater = "SaturationCriticalWater"
    SaturationGas = "SaturationGas"
    SaturationGasResidualOil = "SaturationGasResidualOil"
    SaturationHydrocarbons = "SaturationHydrocarbons"
    SaturationIrreducibleGas = "SaturationIrreducibleGas"
    SaturationIrreducibleWater = "SaturationIrreducibleWater"
    SaturationOil = "SaturationOil"
    SaturationPressure = "SaturationPressure"
    SaturationWater = "SaturationWater"
    SaturationWaterResidualOil = "SaturationWaterResidualOil"
    SimulationTime = "SimulationTime"
    StreamlineBoundaryID = "StreamlineBoundaryID"
    SurfaceTension = "SurfaceTension"
    TransmissibilityI = "TransmissibilityI"
    TransmissibilityJ = "TransmissibilityJ"
    TransmissibilityK = "TransmissibilityK"
    ViscosibilityWater = "ViscosibilityWater"
    ViscosityGas = "ViscosityGas"
    ViscosityOil = "ViscosityOil"
    ViscosityWater = "ViscosityWater"
    WaterHeatCapacity = "WaterHeatCapacity"
    WaterVelocity = "WaterVelocity"
    WellIndex = "WellIndex"

    # Production
    EnergyRate = "EnergyRate"
    EnthalpyFlowRate = "EnthalpyFlowRate"
    GasMassProduction = "GasMassProduction"
    GasMassProductionRate = "GasMassProductionRate"
    InjectionRateGas = "InjectionRateGas"
    InjectionRateOil = "InjectionRateOil"
    InjectionRateReservoirVolume = "InjectionRateReservoirVolume"
    InjectionRateWater = "InjectionRateWater"
    OilMassProduction = "OilMassProduction"
    OilMassProductionRate = "OilMassProductionRate"
    ProductionGas = "ProductionGas"
    ProductionLiquid = "ProductionLiquid"
    ProductionOil = "ProductionOil"
    ProductionRateGas = "ProductionRateGas"
    ProductionRateLiquid = "ProductionRateLiquid"
    ProductionRateOil = "ProductionRateOil"
    ProductionRateReservoirVolume = "ProductionRateReservoirVolume"
    ProductionRateWater = "ProductionRateWater"
    ProductionReservoirVolume = "ProductionReservoirVolume"
    ProductionWater = "ProductionWater"
    RatioGasOil = "RatioGasOil"
    RatioOilGas = "RatioOilGas"
    RatioWaterGas = "RatioWaterGas"
    ReservoirEnergyDensity = "ReservoirEnergyDensity"
    UptimeFraction = "UptimeFraction"
    WaterCut = "WaterCut"
    WaterMassProduction = "WaterMassProduction"
    WaterMassProductionRate = "WaterMassProductionRate"

    # Seismic
    SeismicAntTracking = "SeismicAntTracking"
    SeismicAttenuation = "SeismicAttenuation"
    SeismicConsistentCurvature = "SeismicConsistentCurvature"
    SeismicContrast = "SeismicContrast"
    SeismicCorrelationCoefficient = "SeismicCorrelationCoefficient"
    SeismicCosineOfPhase = "SeismicCosineOfPhase"
    SeismicDefault = "SeismicDefault"
    SeismicDipAngle = "SeismicDipAngle"
    SeismicDipAzimuth = "SeismicDipAzimuth"
    SeismicDipError = "SeismicDipError"
    SeismicDipRatio = "SeismicDipRatio"
    SeismicEdge = "SeismicEdge"
    SeismicFrequency = "SeismicFrequency"
    SeismicGradient = "SeismicGradient"
    SeismicLocalFlatness = "SeismicLocalFlatness"
    SeismicPhase = "SeismicPhase"
    SeismicPolarity = "SeismicPolarity"
    SeismicShapeIndex = "SeismicShapeIndex"
    SeismicVariance = "SeismicVariance"

    # Spatial
    ElevationDepth = "ElevationDepth"
    ElevationProperty = "ElevationProperty"
    ElevationTime = "ElevationTime"
    GeneralTime = "GeneralTime"
    ThicknessDepth = "ThicknessDepth"
    ThicknessGeneral = "ThicknessGeneral"
    ThicknessTime = "ThicknessTime"
    ThicknessTrueStratigraphic = "ThicknessTrueStratigraphic"
    ThicknessTrueVertical = "ThicknessTrueVertical"

    # Volume
    FormationVolumeFactorGas = "FormationVolumeFactorGas"
    FormationVolumeFactorOil = "FormationVolumeFactorOil"
    FormationVolumeFactorWater = "FormationVolumeFactorWater"
    HCPVGas = "HCPVGas"
    HCPVGasMap = "HCPVGasMap"
    HCPVOil = "HCPVOil"
    HCPVOilMap = "HCPVOilMap"
    RatioSolutionGasOil = "RatioSolutionGasOil"
    RatioVaporizedOilGas = "RatioVaporizedOilGas"
    RecoverableGas = "RecoverableGas"
    RecoverableGasMap = "RecoverableGasMap"
    RecoverableOil = "RecoverableOil"
    RecoverableOilMap = "RecoverableOilMap"
    RecoveryFactor = "RecoveryFactor"
    RockVolume = "RockVolume"
    VolumeBulk = "VolumeBulk"
    VolumeBulkMap = "VolumeBulkMap"
    VolumeInitialInPlaceGas = "VolumeInitialInPlaceGas"
    VolumeInitialInPlaceGasMap = "VolumeInitialInPlaceGasMap"
    VolumeInitialInPlaceOil = "VolumeInitialInPlaceOil"
    VolumeInitialInPlaceOilMap = "VolumeInitialInPlaceOilMap"
    VolumeInPlaceGas = "VolumeInPlaceGas"
    VolumeInPlaceOil = "VolumeInPlaceOil"
    VolumeInPlaceWater = "VolumeInPlaceWater"
    VolumeNet = "VolumeNet"
    VolumeNetMap = "VolumeNetMap"
    VolumePore = "VolumePore"
    VolumePoreMap = "VolumePoreMap"
    STOIIP = "STOIIP"
    STOIIPMap = "STOIIPMap"
    GIIP = "GIIP"
    GIIPMap = "GIIPMap"

    # Completions
    CompletionDepth = "CompletionDepth"
    CompletionDiameter = "CompletionDiameter"
    ConnectionTransmissibility = "ConnectionTransmissibility"
    Skin = "Skin"
    PermeabilityLength = "PermeabilityLength"
    PiLiquid = "PiLiquid"
    PiGas = "PiGas"
    PiCompressibleFluid = "PiCompressibleFluid"
    PiMultiplier = "PiMultiplier"
    Roughness = "Roughness"
    DrainageRadius = "DrainageRadius"
    CompletionArea = "CompletionArea"
    IcdStrength = "IcdStrength"

    # ContinuousFractureProperty
    FracturePermeability = "FracturePermeability"
    FractureAperture = "FractureAperture"
    FractureCompressibility = "FractureCompressibility"
                                                                                         
    # PetroleumSystems
    GasGeneration = "GasGeneration"
    OilGeneration = "OilGeneration"
    VitriniteReflectance = "VitriniteReflectance"
    TransformationRatio = "TransformationRatio"
    HeatFlow = "HeatFlow"
    GeologicalTimeScale = "GeologicalTimeScale"
    HydrogenIndex = "HydrogenIndex"
    ThermalGradient = "ThermalGradient"
    WellCalibrationMeasured = "Measured"
    WellCalibrationCalculated = "Calculated"

    # Rock Physics
    SI = "SI"
    GI = "GI"
    E = "E"
    LambdaOverMu = "Lambda/Mu"
    EI2 = "EI2"
    EI3 = "EI3"
    SEI1 = "SEI1"
    SEI2 = "SEI2"
    EEI = "EEI"
    Age = "Age"
